3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
16 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
22 wt_prefix=$(git rev-parse --show-prefix)
25 # Tell the rest of git that any URLs we get don't come
26 # directly from the user, so it can apply policy as appropriate.
27 GIT_PROTOCOL_FROM_USER=0
28 export GIT_PROTOCOL_FROM_USER
48 if test "$1" = "#unmatched"
55 # Print a submodule configuration setting
61 # Checks in the usual git-config places first (for overrides),
62 # otherwise it falls back on .gitmodules. This allows you to
63 # distribute project-wide defaults in .gitmodules, while still
64 # customizing individual repositories if necessary. If the option is
65 # not in .gitmodules either, print a default value.
67 get_submodule_config () {
71 value=$(git config submodule."$name"."$option")
74 value=$(git config -f .gitmodules submodule."$name"."$option")
76 printf '%s' "${value:-$default}"
81 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
84 # Sanitize the local git environment for use within a submodule. We
85 # can't simply use clear_local_git_env since we want to preserve some
86 # of the settings from GIT_CONFIG_PARAMETERS.
87 sanitize_submodule_env()
89 save_config=$GIT_CONFIG_PARAMETERS
91 GIT_CONFIG_PARAMETERS=$save_config
92 export GIT_CONFIG_PARAMETERS
96 # Add a new submodule to the working tree, .gitmodules and the index
100 # optional branch is stored in global branch variable
104 # parse $args after "submodule ... add".
110 case "$2" in '') usage ;; esac
121 case "$2" in '') usage ;; esac
126 reference_path="${1#--reference=}"
129 case "$2" in '') usage ;; esac
134 case "$2" in '') usage ;; esac
155 if test -n "$reference_path"
157 is_absolute_path "$reference_path" ||
158 reference_path="$wt_prefix$reference_path"
160 reference="--reference=$reference_path"
166 if test -z "$sm_path"; then
167 sm_path=$(printf '%s\n' "$repo" |
168 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
171 if test -z "$repo" || test -z "$sm_path"; then
175 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
177 # assure repo is absolute or relative to parent
180 test -z "$wt_prefix" ||
181 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
183 # dereference source url relative to parent's url
184 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
191 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
196 # multiple //; leading ./; /./; /../; trailing /
197 sm_path=$(printf '%s/\n' "$sm_path" |
209 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
210 die "$(eval_gettext "'\$sm_path' already exists in the index")"
212 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
213 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
216 if test -z "$force" &&
217 ! git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" > /dev/null 2>&1
219 eval_gettextln "The following path is ignored by one of your .gitignore files:
221 Use -f if you really want to add it." >&2
225 if test -n "$custom_name"
227 sm_name="$custom_name"
232 # perhaps the path exists and is already a git repo, else clone it
233 if test -e "$sm_path"
235 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
237 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
239 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
243 if test -d ".git/modules/$sm_name"
247 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
248 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
249 die "$(eval_gettextln "\
250 If you want to reuse this local git directory instead of cloning again from
252 use the '--force' option. If the local git directory is not the correct repo
253 or you are unsure what this means choose another name with the '--name' option.")"
255 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
258 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
260 sanitize_submodule_env
262 # ash fails to wordsplit ${branch:+-b "$branch"...}
264 '') git checkout -f -q ;;
265 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
267 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
269 git config submodule."$sm_name".url "$realrepo"
271 git add --no-warn-embedded-repo $force "$sm_path" ||
272 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
274 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
275 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
278 git config -f .gitmodules submodule."$sm_name".branch "$branch"
280 git add --force .gitmodules ||
281 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
283 # NEEDSWORK: In a multi-working-tree world, this needs to be
284 # set in the per-worktree config.
285 if git config --get submodule.active >/dev/null
287 # If the submodule being adding isn't already covered by the
288 # current configured pathspec, set the submodule's active flag
289 if ! git submodule--helper is-active "$sm_path"
291 git config submodule."$sm_name".active "true"
294 git config submodule."$sm_name".active "true"
299 # Execute an arbitrary command sequence in each checked out
302 # $@ = command to execute
306 # parse $args after "submodule ... foreach".
328 # dup stdin so that it can be restored when running the external
329 # command in the subshell (and a recursive call to this function)
333 git submodule--helper list --prefix "$wt_prefix" ||
336 while read -r mode sha1 stage sm_path
338 die_if_unmatched "$mode" "$sha1"
339 if test -e "$sm_path"/.git
341 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
342 say "$(eval_gettext "Entering '\$displaypath'")"
343 name=$(git submodule--helper name "$sm_path")
345 prefix="$prefix$sm_path/"
346 sanitize_submodule_env
348 sm_path=$(git submodule--helper relative-path "$sm_path" "$wt_prefix") &&
349 # we make $path available to scripts ...
357 if test -n "$recursive"
359 cmd_foreach "--recursive" "$@"
362 die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
368 # Register submodules in .git/config
370 # $@ = requested paths (default to all)
374 # parse $args after "submodule ... init".
395 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} "$@"
399 # Unregister submodules from .git/config and remove their work tree
403 # parse $args after "submodule ... deinit".
431 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper deinit ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} ${force:+--force} ${deinit_all:+--all} "$@"
434 is_tip_reachable () (
435 sanitize_submodule_env &&
437 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
441 fetch_in_submodule () (
442 sanitize_submodule_env &&
449 git fetch $(get_default_remote) "$@" ;;
454 # Update each submodule path to correct revision, using clone and checkout as needed
456 # $@ = requested paths (default to all)
460 # parse $args after "submodule ... update".
468 progress="--progress"
486 case "$2" in '') usage ;; esac
487 reference="--reference=$2"
503 recommend_shallow="--recommend-shallow"
505 --no-recommend-shallow)
506 recommend_shallow="--no-recommend-shallow"
509 case "$2" in '') usage ;; esac
517 case "$2" in '') usage ;; esac
540 cmd_init "--" "$@" || return
544 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
545 ${progress:+"$progress"} \
546 ${wt_prefix:+--prefix "$wt_prefix"} \
547 ${prefix:+--recursive-prefix "$prefix"} \
548 ${update:+--update "$update"} \
549 ${reference:+"$reference"} \
550 ${depth:+--depth "$depth"} \
551 ${recommend_shallow:+"$recommend_shallow"} \
553 "$@" || echo "#unmatched" $?
556 while read -r mode sha1 stage just_cloned sm_path
558 die_if_unmatched "$mode" "$sha1"
560 name=$(git submodule--helper name "$sm_path") || exit
561 if ! test -z "$update"
563 update_module=$update
565 update_module=$(git config submodule."$name".update)
566 if test -z "$update_module"
568 update_module="checkout"
572 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
574 if test $just_cloned -eq 1
577 case "$update_module" in
578 merge | rebase | none)
579 update_module=checkout ;;
582 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
583 git rev-parse --verify HEAD) ||
584 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
589 branch=$(git submodule--helper remote-branch "$sm_path")
590 if test -z "$nofetch"
592 # Fetch remote before determining tracking $sha1
593 fetch_in_submodule "$sm_path" $depth ||
594 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
596 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
597 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
598 git rev-parse --verify "${remote_name}/${branch}") ||
599 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
602 if test "$subsha1" != "$sha1" || test -n "$force"
605 # If we don't already have a -f flag and the submodule has never been checked out
606 if test -z "$subsha1" && test -z "$force"
611 if test -z "$nofetch"
613 # Run fetch only if $sha1 isn't present or it
614 # is not reachable from a ref.
615 is_tip_reachable "$sm_path" "$sha1" ||
616 fetch_in_submodule "$sm_path" $depth ||
617 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
619 # Now we tried the usual fetch, but $sha1 may
620 # not be reachable from any of the refs
621 is_tip_reachable "$sm_path" "$sha1" ||
622 fetch_in_submodule "$sm_path" $depth "$sha1" ||
623 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
627 case "$update_module" in
629 command="git checkout $subforce -q"
630 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
631 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
635 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
636 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
637 must_die_on_failure=yes
641 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
642 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
643 must_die_on_failure=yes
646 command="${update_module#!}"
647 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
648 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
649 must_die_on_failure=yes
652 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
655 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
658 elif test -n "$must_die_on_failure"
660 die_with_status 2 "$die_msg"
662 err="${err};$die_msg"
667 if test -n "$recursive"
670 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
672 sanitize_submodule_env
679 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
682 err="${err};$die_msg"
685 die_with_status $res "$die_msg"
709 # Show commit summary for submodules in index or working tree
711 # If '--cached' is given, show summary between index and given commit,
712 # or between working tree and given commit
714 # $@ = [commit (default 'HEAD'),] requested paths (default all)
721 # parse $args after "submodule ... summary".
736 isnumber "$summary_limit" || usage
740 summary_limit="${1#--summary-limit=}"
741 isnumber "$summary_limit" || usage
757 test $summary_limit = 0 && return
759 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
763 elif test -z "$1" || test "$1" = "HEAD"
765 # before the first commit: compare with an empty tree
766 head=$(git hash-object -w -t tree --stdin </dev/null)
767 test -z "$1" || shift
775 die "$(gettext "The --cached option cannot be used with the --files option")"
781 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
782 # Get modified modules cared by user
783 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
784 sane_egrep '^:([0-7]* )?160000' |
785 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
787 # Always show modules deleted or type-changed (blob<->module)
788 if test "$status" = D || test "$status" = T
790 printf '%s\n' "$sm_path"
793 # Respect the ignore setting for --for-status.
794 if test -n "$for_status"
796 name=$(git submodule--helper name "$sm_path")
797 ignore_config=$(get_submodule_config "$name" ignore none)
798 test $status != A && test $ignore_config = all && continue
800 # Also show added or modified modules which are checked out
801 GIT_DIR="$sm_path/.git" git rev-parse --git-dir >/dev/null 2>&1 &&
802 printf '%s\n' "$sm_path"
806 test -z "$modules" && return
808 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
809 sane_egrep '^:([0-7]* )?160000' |
811 while read -r mod_src mod_dst sha1_src sha1_dst status name
813 if test -z "$cached" &&
814 test $sha1_dst = 0000000000000000000000000000000000000000
818 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
820 100644 | 100755 | 120000)
821 sha1_dst=$(git hash-object $name)
827 eval_gettextln "unexpected mode \$mod_dst" >&2
834 test $mod_src = 160000 &&
835 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_src^0 >/dev/null &&
838 test $mod_dst = 160000 &&
839 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_dst^0 >/dev/null &&
842 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
845 case "$missing_src,$missing_dst" in
847 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
850 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
853 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
858 if test $mod_src = 160000 && test $mod_dst = 160000
860 range="$sha1_src...$sha1_dst"
861 elif test $mod_src = 160000
867 GIT_DIR="$name/.git" \
868 git rev-list --first-parent $range -- | wc -l
870 total_commits=" ($(($total_commits + 0)))"
874 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
875 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
878 blob="$(gettext "blob")"
879 submodule="$(gettext "submodule")"
880 if test $mod_dst = 160000
882 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
884 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
887 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
891 # Don't give error msg for modification whose dst is not submodule
892 # i.e. deleted or changed to blob
893 test $mod_dst = 160000 && echo "$errmsg"
895 if test $mod_src = 160000 && test $mod_dst = 160000
898 test $summary_limit -gt 0 && limit="-$summary_limit"
899 GIT_DIR="$name/.git" \
900 git log $limit --pretty='format: %m %s' \
901 --first-parent $sha1_src...$sha1_dst
902 elif test $mod_dst = 160000
904 GIT_DIR="$name/.git" \
905 git log --pretty='format: > %s' -1 $sha1_dst
907 GIT_DIR="$name/.git" \
908 git log --pretty='format: < %s' -1 $sha1_src
916 # List all submodules, prefixed with:
917 # - submodule not initialized
918 # + different revision checked out
920 # If --cached was specified the revision in the index will be printed
921 # instead of the currently checked out revision.
923 # $@ = requested paths (default to all)
927 # parse $args after "submodule ... status".
954 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper status ${GIT_QUIET:+--quiet} ${cached:+--cached} ${recursive:+--recursive} "$@"
957 # Sync remote urls for submodules
958 # This makes the value for remote.$remote.url match the value
959 # specified in .gitmodules.
987 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper sync ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
992 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
995 # This loop parses the command line arguments to find the
996 # subcommand name to dispatch. Parsing of the subcommand specific
997 # options are primarily done by the subcommand implementations.
998 # Subcommand specific options such as --branch and --cached are
999 # parsed here as well, for backward compatibility.
1001 while test $# != 0 && test -z "$command"
1004 add | foreach | init | deinit | update | status | summary | sync | absorbgitdirs)
1034 # No command word defaults to "status"
1035 if test -z "$command"
1045 # "-b branch" is accepted only by "add"
1046 if test -n "$branch" && test "$command" != add
1051 # "--cached" is accepted only by "status" and "summary"
1052 if test -n "$cached" && test "$command" != status && test "$command" != summary